package com.example.shareaccount;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.net.HttpURLConnection;
import java.net.URL;
import java.net.URLEncoder;
import java.util.ArrayList;
import android.util.Log;

public class AccessBD{
	
	private static int acc_id;
	
	protected static ArrayList<Account> accounts = listAccounts();
	protected static ArrayList<Friend> friends = listFriends(acc_id);
				
	public static ArrayList<Account> listAccounts(){
			ArrayList<Account> accounts = new ArrayList<Account>();
			try{
				URL url = new URL("http://yvives.hostinazo.com/ShareAccount/list_accounts.php" + "?max=20");
				HttpURLConnection conexion = (HttpURLConnection) url.openConnection();
				if (conexion.getResponseCode() == HttpURLConnection.HTTP_OK){
					BufferedReader reader = new BufferedReader(new InputStreamReader(conexion.getInputStream()));
					String linea = reader.readLine();
					while (!linea.equals("")){
						Account account = new Account();
						String[] strArray=linea.split(",");
						for(int i=0; i<strArray.length;i++) {
						    account.setName(strArray[0].toString()); 
						    TypeAccount type = null;
						    switch (strArray[1]){
							case "MEAL":
								type = TypeAccount.MEAL;
								break;
							case "LOTTO":
								type = TypeAccount.LOTTO;
								break;
							case "RENT":
								type = TypeAccount.RENT;
								break;
							case "PRESENT":
								type = TypeAccount.PRESENT;
								break;
							case "TRAVEL":
								type = TypeAccount.TRAVEL;
								break;
							}
						    account.setType(type);
						    account.setAmount(strArray[2].toString());
						}
						accounts.add(account);
						linea = reader.readLine();
					}
					reader.close();
					return accounts;
				} else {
					Log.e("list_accounts", conexion.getResponseMessage());
					return accounts;
				}
	
			} catch (Exception e) {
				Log.e("list_accounts", e.getMessage(), e);
				return accounts;
			}
		
	}
	
	public static int sizeAcc(){
		return accounts.size();
	}
	
	public static Account acc_element(int id){
		return accounts.get(id);
	}
	
		
	public static int saveAccount(Account account){
		String name = account.getName().toString();
		String type = account.getType().toString();
		String amount = account.getAmount().toString();
		String linea = null;
		int acc_id = 0;
		try{
			URL url = new URL("http://yvives.hostinazo.com/ShareAccount/save_account.php"
					+ "?name=" + URLEncoder.encode(name, "UTF-8")
					+ "&type=" + URLEncoder.encode(type, "UTF-8")
					+ "&amount=" + URLEncoder.encode(amount, "UTF-8"));
			HttpURLConnection conexion = (HttpURLConnection) url.openConnection();
			if (conexion.getResponseCode() == HttpURLConnection.HTTP_OK){
				BufferedReader reader = new BufferedReader(new InputStreamReader(conexion.getInputStream()));
				 linea = reader.readLine();
				 acc_id = Integer.parseInt(linea);
			} else {
				Log.e("save_account", conexion.getResponseMessage());
			}
			conexion.disconnect();
		} catch (Exception e){
			Log.e("save_account", e.getMessage(), e);
		}
		return  acc_id;
	}
	
	public static void updateAccount(Account account, int acc_id){
		String name = account.getName().toString();
		String type = account.getType().toString();
		String amount = account.getAmount().toString();
		String linea = null;
		try{
			URL url = new URL("http://yvives.hostinazo.com/ShareAccount/update_account.php"
					+ "?acc_id=" + acc_id
					+ "&name=" + URLEncoder.encode(name, "UTF-8")
					+ "&type=" + URLEncoder.encode(type, "UTF-8")
					+ "&amount=" + URLEncoder.encode(amount, "UTF-8"));
			HttpURLConnection conexion = (HttpURLConnection) url.openConnection();
			if (conexion.getResponseCode() == HttpURLConnection.HTTP_OK){
				BufferedReader reader = new BufferedReader(new InputStreamReader(conexion.getInputStream()));
				 linea = reader.readLine();
				while (!linea.equals("OK")){
					Log.e("update_account", "Error en servicio web saveAccount");
				}
			} else {
				Log.e("update_account", conexion.getResponseMessage());
			}
			conexion.disconnect();
		} catch (Exception e){
			Log.e("update_account", e.getMessage(), e);
		}
	}
	
	public static void deleteAccount(int acc_id){
		String linea = null;
		try{
			URL url = new URL("http://yvives.hostinazo.com/ShareAccount/delete_account.php"
					+ "?acc_id=" + acc_id);
			HttpURLConnection conexion = (HttpURLConnection) url.openConnection();
			if (conexion.getResponseCode() == HttpURLConnection.HTTP_OK){
				BufferedReader reader = new BufferedReader(new InputStreamReader(conexion.getInputStream()));
				 linea = reader.readLine();
				while (!linea.equals("OK")){
					Log.e("delete_account", "Error en servicio web saveAccount");
				}
			} else {
				Log.e("delete_account", conexion.getResponseMessage());
			}
			conexion.disconnect();
		} catch (Exception e){
			Log.e("delete_account", e.getMessage(), e);
		}
	}
	
	public static int getAccountId(Account account){
		String name = account.getName().toString();
		String linea = null;
		int acc_id = 0;
		try{
			URL url = new URL("http://yvives.hostinazo.com/ShareAccount/getAccountId.php"
					+ "?name=" + URLEncoder.encode(name, "UTF-8"));
			HttpURLConnection conexion = (HttpURLConnection) url.openConnection();
			if (conexion.getResponseCode() == HttpURLConnection.HTTP_OK){
				BufferedReader reader = new BufferedReader(new InputStreamReader(conexion.getInputStream()));
				 linea = reader.readLine();
				 acc_id = Integer.parseInt(linea);
			} else {
				Log.e("getAccountId", conexion.getResponseMessage());
			}
			conexion.disconnect();
		} catch (Exception e){
			Log.e("getAccountId", e.getMessage(), e);
		}
		return acc_id;
	}
	
	public static ArrayList<Friend> listFriends(int acc_id){
		ArrayList<Friend> friends = new ArrayList<Friend>();
		try{
			URL url = new URL("http://yvives.hostinazo.com/ShareAccount/list_friends.php?" + "&acc_id=" + acc_id);
			HttpURLConnection conexion = (HttpURLConnection) url.openConnection();
			if (conexion.getResponseCode() == HttpURLConnection.HTTP_OK){
				BufferedReader reader = new BufferedReader(new InputStreamReader(conexion.getInputStream()));
				String linea = reader.readLine();
				while (!linea.equals("")){
					Friend friend = new Friend();
					String[] strArray=linea.split(",");
					for(int i=0; i<strArray.length;i++) {
						friend.setCuenta(Integer.parseInt(strArray[0]));
					    friend.setUserName(strArray[1].toString()); 
					    friend.setPaid(strArray[2].toString());
					    friend.setTopay(strArray[3].toString());
					    friend.setComments(strArray[4].toString());
					}
					friends.add(friend);
					linea = reader.readLine();
				}
				reader.close();
				return friends;
			} else {
				Log.e("list_friends", conexion.getResponseMessage());
				return friends;
			}

		} catch (Exception e) {
			Log.e("list_friends", e.getMessage(), e);
			return friends;
		}
	
	}
	
	
	public static int sizeFr(){
		return friends.size();
	}
	
	public static Friend fr_element(int id, int acc_id){
		ArrayList<Friend> friends2 = listFriends(acc_id);
		return friends2.get(id);
	}
	
	public static void deleteFriendsAccId(int acc_id){
		String linea = null;
		try{
			URL url = new URL("http://yvives.hostinazo.com/ShareAccount/delete_friendsId.php"
					+ "?acc_id=" + acc_id);
			HttpURLConnection conexion = (HttpURLConnection) url.openConnection();
			if (conexion.getResponseCode() == HttpURLConnection.HTTP_OK){
				BufferedReader reader = new BufferedReader(new InputStreamReader(conexion.getInputStream()));
				 linea = reader.readLine();
				while (!linea.equals("OK")){
					Log.e("delete_friendsId", "Error en servicio web saveAccount");
				}
			} else {
				Log.e("delete_friendsId", conexion.getResponseMessage());
			}
			conexion.disconnect();
		} catch (Exception e){
			Log.e("delete_friendsId", e.getMessage(), e);
		}
	}
	
public static void deleteFriend(int fr_id){
		String linea = null;
		try{
			URL url = new URL("http://yvives.hostinazo.com/ShareAccount/delete_friend.php"
					+ "?fr_id=" + fr_id);
			HttpURLConnection conexion = (HttpURLConnection) url.openConnection();
			if (conexion.getResponseCode() == HttpURLConnection.HTTP_OK){
				BufferedReader reader = new BufferedReader(new InputStreamReader(conexion.getInputStream()));
				 linea = reader.readLine();
				while (!linea.equals("OK")){
					Log.e("delete_friend", "Error en servicio web saveAccount");
				}
			} else {
				Log.e("delete_friend", conexion.getResponseMessage());
			}
			conexion.disconnect();
		} catch (Exception e){
			Log.e("delete_friend", e.getMessage(), e);
		}
	}
	
	
	public static void saveFriend(Friend friend){
		int acc_id = friend.getCuenta();
		String username = friend.getUserName().toString();
		String paid = friend.getPaid().toString();
		String topay = null;
		String comments = friend.getComments().toString();
		try{
			URL url = new URL("http://yvives.hostinazo.com/ShareAccount/save_friends.php"
					+ "?cuenta=" + acc_id
					+ "&username=" + URLEncoder.encode(username, "UTF-8") 
					+ "&paid=" + URLEncoder.encode(paid, "UTF-8") 
					+ "&topay=" + topay 
					+ "&comments=" + URLEncoder.encode(comments, "UTF-8"));
			HttpURLConnection conexion = (HttpURLConnection) url.openConnection();
			if (conexion.getResponseCode() == HttpURLConnection.HTTP_OK){
				BufferedReader reader = new BufferedReader(new InputStreamReader(conexion.getInputStream()));
				String linea = reader.readLine();
				while (!linea.equals("OK")){
					Log.e("save_friend", "Error en servicio web saveFriends");
				}
			} else {
				Log.e("save_friend", conexion.getResponseMessage());
			}
			conexion.disconnect();
		} catch (Exception e){
			Log.e("save_friend", e.getMessage(), e);
		}
		

	}
	
	public static void updateFriend(Friend friend, int fr_id, int acc_id){
		String username = friend.getUserName().toString();
		String paid = friend.getPaid().toString();
		String topay = friend.getTopay().toString();
		String comments = friend.getComments().toString();
		String linea = null;
		try{
			URL url = new URL("http://yvives.hostinazo.com/ShareAccount/update_friend.php"
					+ "?fr_id=" + fr_id
					+ "&acc_id=" + acc_id
					+ "&username=" + URLEncoder.encode(username, "UTF-8")
					+ "&paid=" + URLEncoder.encode(paid, "UTF-8")
					+ "&topay=" + URLEncoder.encode(topay, "UTF-8")
					+ "&comments=" + URLEncoder.encode(comments, "UTF-8"));
			HttpURLConnection conexion = (HttpURLConnection) url.openConnection();
			if (conexion.getResponseCode() == HttpURLConnection.HTTP_OK){
				BufferedReader reader = new BufferedReader(new InputStreamReader(conexion.getInputStream()));
				 linea = reader.readLine();
				while (!linea.equals("OK")){
					Log.e("update_friend", "Error en servicio web updateFriend");
				}
			} else {
				Log.e("update_friend", conexion.getResponseMessage());
			}
			conexion.disconnect();
		} catch (Exception e){
			Log.e("update_friend", e.getMessage(), e);
		}
	}
	
	public static int getFriendId(Friend friend){
		String username = friend.getUserName().toString();
		String linea = null;
		int fr_id = 0;
		try{
			URL url = new URL("http://yvives.hostinazo.com/ShareAccount/getFriendId.php"
					+ "?username=" + URLEncoder.encode(username, "UTF-8"));
			HttpURLConnection conexion = (HttpURLConnection) url.openConnection();
			if (conexion.getResponseCode() == HttpURLConnection.HTTP_OK){
				BufferedReader reader = new BufferedReader(new InputStreamReader(conexion.getInputStream()));
				 linea = reader.readLine();
				 fr_id = Integer.parseInt(linea);
			} else {
				Log.e("getFriendId", conexion.getResponseMessage());
			}
			conexion.disconnect();
		} catch (Exception e){
			Log.e("getFriendId", e.getMessage(), e);
		}
		return fr_id;
	}
}
