package com.example.shareaccount;

import java.util.ArrayList;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.ImageView;
import android.widget.TextView;

public class AccountsAdapter extends BaseAdapter {
    private ArrayList<Account> accounts;
	Context contexto;
	
     public AccountsAdapter(Context contexto, ArrayList<Account> accounts) {
    	this.contexto = contexto;
        this.accounts = accounts;
    }
    
    private class ViewHolder{
    	TextView name;
        ImageView foto;
        TextView type;
        TextView amount;
    }

    public View getView(int position, View recycledView, ViewGroup father) {
    	ViewHolder holder = null;
    	        
    	if (recycledView == null){
    		LayoutInflater inflater = (LayoutInflater) contexto.getSystemService(Context.LAYOUT_INFLATER_SERVICE);
    		recycledView = inflater.inflate(R.layout.account_element,null);
    		
    	} 
    	
    	holder = new ViewHolder();
        holder.name = (TextView) recycledView.findViewById(R.id.name);
        holder.foto = (ImageView) recycledView.findViewById(R.id.foto);
        holder.type = (TextView) recycledView.findViewById(R.id.type);
        holder.amount = (TextView) recycledView.findViewById(R.id.amount);
        
        holder.name.setText(accounts.get(position).getName().toString());
        int id = R.drawable.meal;
              
        switch(accounts.get(position).getType()) {
	        case MEAL:   id = R.drawable.meal; break;
	        case RENT:     id = R.drawable.rent;   break;
	        case LOTTO:    id = R.drawable.lotto;  break;
	        case TRAVEL:   id = R.drawable.travel; break;
	        case PRESENT:  id = R.drawable.present;break;
        }
        
        holder.foto.setImageResource(id);
        holder.foto.setScaleType(ImageView.ScaleType.FIT_END);
        holder.type.setText(accounts.get(position).getType().toString());
        holder.amount.setText(accounts.get(position).getAmount().toString());
        
        return recycledView;
    }

    public int getCount() {
        return accounts.size();
    }

    public Object getItem(int position) {
        return accounts.get(position);
    }

    public long getItemId(int position) {
        return accounts.indexOf(getItem(position));
    }

}



