package com.example.shareaccount;

import android.app.Activity;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.EditText;

public class AddNewFriend extends Activity implements OnClickListener {
	
	private static Button bAddFriendButton;
	private static Button bCancelButton;
	private EditText userName;
	private EditText Paid;
	private EditText Comments;
	private static final String LOG_TAG = "AddFriend";
	private long acc_id;
	
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.add_new_friend);
		Bundle extras = getIntent().getExtras();
		acc_id = extras.getLong("acc_id", acc_id); 
				
		bAddFriendButton = (Button)findViewById(R.id.addFriend);
		bCancelButton = (Button)findViewById(R.id.cancel);
		userName = (EditText)findViewById(R.id.username);
		Paid = (EditText)findViewById(R.id.paid);
		Comments = (EditText)findViewById(R.id.comments);
		
		if (bAddFriendButton != null) {
			bAddFriendButton.setOnClickListener(this);
		} else {
			Log.e(LOG_TAG, "onCreate: bAddFriendButton is null");
			throw new NullPointerException("onCreate: bAddFriendButton is null");
		}
		
		if (bCancelButton != null) {
			bCancelButton.setOnClickListener(this);
		} else {
			Log.e(LOG_TAG, "onCreate: bCancelButton is null");
			throw new NullPointerException("onCreate: bCancelButton is null");
		}
	}

	@Override
	public void onClick(View view) {
		if (view == bCancelButton) {
			finish();
		} else if (view == bAddFriendButton) {
			Friend friend = new Friend();
			friend.setCuenta((int)acc_id);
			friend.setUserName(userName.getText().toString());
			friend.setPaid(Paid.getText().toString());
			friend.setTopay(null);
			friend.setComments(Comments.getText().toString());

			AccessBD.saveFriend(friend);
			finish();
		} else {
			Log.e(LOG_TAG, "onClick: view clicked is unknown");
		}
	}
	
	
}
