package com.example.shareaccount;

import java.util.ArrayList;

import android.app.ListActivity;
import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ListView;
import android.widget.Spinner;

public class EditAccount extends ListActivity{
	private long acc_id;
	private long id;
	private Account account;
	private EditText name;
	private Spinner type;
	private EditText amount;
	private Button bFriends;
	private Button bSave;
	public FriendsAdapter friendsadapter ;
	private int total_paid;
	private int total_amount;
	private int num;
	
	@Override
	protected void onCreate(Bundle savedInstanceState){
		super.onCreate(savedInstanceState);
		setContentView(R.layout.edit_account);
		Bundle extras = getIntent().getExtras();
		//Toast.makeText(this,String.valueOf((int)acc_id) , Toast.LENGTH_LONG).show();
		id = extras.getLong("id", id);
		account = AccessBD.acc_element((int) id);
		acc_id = AccessBD.getAccountId(account);
		
		name = (EditText) findViewById(R.id.name);
		name.setText(account.getName());
		
		type = (Spinner) findViewById(R.id.type);
		ArrayAdapter<String> adaptador = new ArrayAdapter<String>(this, android.R.layout.simple_spinner_item, TypeAccount.getNames());
		adaptador.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
		
		type.setAdapter(adaptador);
				
		bFriends=(Button) findViewById(R.id.b_friends);
		bFriends.setOnClickListener(new OnClickListener() {
			public void onClick(View view){
				runFriends(null, acc_id);
			}
		});
		
		bSave=(Button) findViewById(R.id.b_save);
		bSave.setOnClickListener(new OnClickListener(){
			public void onClick(View view){
				account.setName(name.getText().toString());
				account.setType(TypeAccount.values()[type.getSelectedItemPosition()]);
				account.setAmount(amount.getText().toString());
				AccessBD.updateAccount(account, (int) acc_id);
				finish();
			}
		});
		
		amount = (EditText) findViewById(R.id.amount);
		amount.setText(account.getAmount());

		actualizarFriends();
	}
	
	public void runFriends(View view, long acc_id){
		Intent i = new Intent(this, AddNewFriend.class);
		i.putExtra("acc_id", acc_id);
		startActivityForResult(i,1236);
	}
	
	@Override
	protected void onActivityResult(int requestCode, int resultCode, Intent data){
		if(requestCode == 1236){
			ArrayList<Friend> friends = AccessBD.listFriends((int)acc_id);
			int count = friends.size();
			total_amount = Integer.parseInt(amount.getText().toString());
			for(int s=0;s<count;s++){
	            total_paid = Integer.parseInt((friends.get(s)).getPaid().toString());
	            num = (total_amount/count) - total_paid;
	    		friends.get(s).setTopay(String.valueOf(num));
	    		int fr_id = AccessBD.getFriendId(friends.get(s));
	    		AccessBD.updateFriend(friends.get(s), fr_id, (int) acc_id);
	        }
			actualizarFriends();
		}
	}
	
	public void actualizarFriends(){
		friendsadapter = new FriendsAdapter(this, AccessBD.listFriends((int)acc_id));
		setListAdapter(friendsadapter);
	}
	
	protected void onListItemClick(ListView listView, View vista, int position, long id2){
		super.onListItemClick(listView, vista, position, id2);
		Intent i = new Intent(this, ViewFriend.class);
		i.putExtra("id2", id2);
		i.putExtra("acc_id", acc_id);
		startActivityForResult(i,1236);
	}
}
