package com.example.shareaccount;

import java.util.ArrayList;
import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.TextView;

public class FriendsAdapter extends BaseAdapter {
	private ArrayList<Friend> friends;
	Context contexto;

    public FriendsAdapter(Context contexto, ArrayList<Friend> friends){
    	this.contexto = contexto;
        this.friends = friends;
    }
    
    private class ViewHolder{
    	TextView username;
    	TextView paid;
    	TextView topay;
    	TextView comments;
    }

    public View getView(int position, View recycledView, ViewGroup father) {
    	ViewHolder holder = null;
    	
        
    	if (recycledView == null){
    		LayoutInflater inflater = (LayoutInflater) contexto.getSystemService(Context.LAYOUT_INFLATER_SERVICE);
    		recycledView = inflater.inflate(R.layout.friend_element,null);
    		
    	} 
    	
    	holder = new ViewHolder();
		holder.username = (TextView) recycledView.findViewById(R.id.username);
		holder.paid = (TextView) recycledView.findViewById(R.id.paid);
		holder.topay = (TextView) recycledView.findViewById(R.id.topay);
		holder.comments = (TextView) recycledView.findViewById(R.id.comments);
    	
        holder.username.setText(friends.get(position).getUserName().toString());
        holder.paid.setText(friends.get(position).getPaid().toString());
    	holder.topay.setText(friends.get(position).getTopay().toString());
    	holder.comments.setText(friends.get(position).getComments().toString());
                       
        return recycledView;
    }
    
    @Override
    public int getCount() {
    	return friends.size();
    }

    @Override
    public Object getItem(int position) {
    	return friends.get(position);
    }

    @Override
    public long getItemId(int position) {
        return friends.indexOf(getItem(position));
    }

}
