package com.example.shareaccount;

import android.app.ListActivity;
import android.content.Intent;
import android.os.Bundle;
import android.os.StrictMode;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.ListView;
import android.widget.Toast;

public class MainActivity extends ListActivity {

	public AccountsAdapter adaptador;
	private String type;
		
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_main);
				
		StrictMode.setThreadPolicy(new StrictMode.ThreadPolicy.Builder().permitNetwork().build());
		actualizarVistas();
	}
	
	@Override public boolean onCreateOptionsMenu(Menu menu){
		getMenuInflater().inflate(R.menu.main, menu);
		return true;
	}
	
	@Override public boolean onOptionsItemSelected(MenuItem item){
		switch (item.getItemId()){
		case R.id.about:
			runAbout(null);
			break;
		case R.id.add_acc:
			runAddAccount(null);
			break;
		}
		return true;
	}
	
	public void runAddAccount(View view){
		Intent i = new Intent(this, AddAccount.class);
		startActivityForResult(i,1234);
	}
	
	public void runAbout(View view){
		Intent i = new Intent(this, About.class);
		startActivity(i);
	}
	
	@Override
	protected void onListItemClick(ListView listView, View vista, int position, long id){
		super.onListItemClick(listView, vista, position, id);
		Account account = AccessBD.acc_element((int) id);
		type = account.getType().toString();
		
		switch (type){
			case "MEAL":
				Intent i1 = new Intent(this, ViewAccountMeal.class);
				i1.putExtra("id", id);
				startActivityForResult(i1,1234);
				break;
			case "PRESENT":
				Intent i2 = new Intent(this, ViewAccountPresent.class);
				i2.putExtra("id", id);
				startActivityForResult(i2,1234);
				break;
			case "RENT":
				Intent i3 = new Intent(this, ViewAccountRent.class);
				i3.putExtra("id", id);
				startActivityForResult(i3,1234);
				break;
			case "LOTTO":
				Intent i4 = new Intent(this, ViewAccountLotto.class);
				i4.putExtra("id", id);
				startActivityForResult(i4,1234);
				break;
			case "TRAVEL":
				Intent i5 = new Intent(this, ViewAccountTravel.class);
				i5.putExtra("id", id);
				startActivityForResult(i5,1234);
				break;
		}
	}
	
	public void actualizarVistas(){
		adaptador = new AccountsAdapter(this, AccessBD.listAccounts());
		setListAdapter(adaptador);
	}
	
	@Override
	protected void onActivityResult(int requestCode, int resultCode, Intent data){
		if(requestCode == 1234){
			actualizarVistas();
		}
		
	}
	
}
