package com.example.shareaccount;

public enum TypeAccount {
	MEAL("Meal", R.drawable.meal),
	RENT("Rent", R.drawable.rent),
	LOTTO("Lotto", R.drawable.lotto),
	TRAVEL("Travel", R.drawable.travel),
	PRESENT("Present", R.drawable.present);
	
	private final String text;
	private final int resource;
	
	TypeAccount(String text, int resource){
		this.text = text;
		this.resource = resource;
	}
	
	public static String[] getNames(){
		String[] result = new String[TypeAccount.values().length];
		for (TypeAccount type : TypeAccount.values()){
			result[type.ordinal()] = type.text;
		}
		return result;
	}
	
	public String getText(){
		return text;
	}
	
	public int getResource(){
		return resource;
	}
}
