package com.example.shareaccount;

import android.app.ListActivity;
import android.content.Intent;
import android.os.Bundle;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.ListView;
import android.widget.TextView;

public class ViewAccountTravel extends ListActivity{
	private long acc_id;
	private long id;
	private Account account;
	public FriendsAdapter friendsadapter;
	private TextView name;
	private TextView amount;
	
	@Override
	protected void onCreate(Bundle savedInstanceState){
		super.onCreate(savedInstanceState);
		setContentView(R.layout.view_account_travel);
		Bundle extras = getIntent().getExtras();
		id = extras.getLong("id", id);
		//Toast.makeText(this,String.valueOf((int)acc_id) , Toast.LENGTH_LONG).show();
		
		account = AccessBD.acc_element((int)id);
		acc_id = AccessBD.getAccountId(account);
		name = (TextView) findViewById(R.id.name);
		name.setText(account.getName());
		amount = (TextView) findViewById(R.id.amount);
		amount.setText(account.getAmount());
		
		actualizar();
		
	}
	
	@Override public boolean onCreateOptionsMenu(Menu menu){
		getMenuInflater().inflate(R.menu.view_menu, menu);
		return true;
	}
	
	@Override public boolean onOptionsItemSelected(MenuItem item){
		switch (item.getItemId()){
		case R.id.rem:
			AccessBD.deleteFriendsAccId((int) acc_id);
			AccessBD.deleteAccount((int) acc_id);
			finish();
			break;
		case R.id.edit:
			runEditAccount(null);
			break;
		}
		return true;
	}
	
	public void runEditAccount(View view){
		Intent i = new Intent(this, EditAccount.class);
		i.putExtra("id", id);	
		startActivityForResult(i,1237);
	}
	
	@Override
	protected void onListItemClick(ListView listView, View vista, int position, long id2){
		super.onListItemClick(listView, vista, position, id2);
			Intent i = new Intent(this, ViewFriend.class);
			i.putExtra("id2", id2);
			i.putExtra("acc_id", acc_id);
			i.putExtra("amount", Integer.parseInt(account.getAmount()));
			startActivityForResult(i,1237);
	}
	
	public void actualizar(){
		account = AccessBD.acc_element((int)id);
		name.setText(account.getName());
		amount.setText(account.getAmount());

		friendsadapter = new FriendsAdapter(this, AccessBD.listFriends((int)acc_id));
		setListAdapter(friendsadapter);
	}
	
	@Override
	protected void onActivityResult(int requestCode, int resultCode, Intent data){
		if(requestCode == 1237){
			actualizar();
		}
		
	}
}